codeforces55D(数位DP)

地址:http://codeforces.com/problemset/problem/55/D

D. Beautiful numbers
time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Volodya is an odd boy and his taste is strange as well. It seems to him that a positive integer number is beautiful if and only if it is divisible by each of its nonzero digits. We will not argue with this and just count the quantity of beautiful numbers in given ranges.

Input

The first line of the input contains the number of cases t (1 ≤ t ≤ 10). Each of the next t lines contains two natural numbers li and ri (1 ≤ li ≤ ri ≤ 9 ·1018).

Please, do not use %lld specificator to read or write 64-bit integers in C++. It is preffered to use cin (also you may use %I64d).

Output

Output should contain t numbers — answers to the queries, one number per line — quantities of beautiful numbers in given intervals (from li to ri, inclusively).

Sample test(s)
input
1
1 9
output
9
input
1
12 15
output
2

题意:找在区间内的beautiful number的数量,beautiful number的要求是概数能被其每一位数字整除。

思路:本来我想开四维数组,一个是数字位数,一个是首位数字,一个是各数位最小公倍数,一个是当前数字对这个最小公倍数的余数。这里有个难点在于如果最小公倍数改变了,那么以前保留的余数该怎么变化,所以要再开一维记录除数。但开5维数组不仅超空间,还超时间,所以就放弃了。看了下大神的优化,主要想法没变,但是处理起来就不一样了。建立三维数组,一个记录数字位数,一个记录各数位最小公倍数,一个记录当前几位数除以1~9的最小公倍数2520的余数。这里要开2520平方大的数组,太大了,所以离散一下1~9的最小公倍数,而且当前位数除以2520的余数可以看成当前位数除以252的余数(注意最后一位的处理)。这样既省时又省空间。

代码:

#include<iostream>
#include<cstdio>
#include<cmath>
#include<cstring>
using namespace std;
#define LL __int64
LL dp[20][50][255];  //三维记录数组
int num[20],a[2550],b[255][10]={0};
int gcd(int a,int b)
{
    if(!b) return a;
    else return gcd(b,a%b);
}
int lcm(int a,int b)
{
    return a*b/gcd(a,b);
}
LL dfs(int len,int m,int n,bool p)  //len是数字位数,m是最小公倍数,n是对2520的余数
{
    if(!len) return n%m==0;
    if(!p&&dp[len][a[m]][n]>=0) return dp[len][a[m]][n];
    int maxx=p?num[len]:9;
    LL ans=0;
    for(int i=0;i<=maxx;i++)
        ans+=dfs(len-1,i?lcm(m,i):m,len==1?n*10+i:b[n][i],i==maxx&p);
    if(!p) dp[len][a[m]][n]=ans;
    return ans;
}
LL getans(LL m)
{
    int len=0;
    for(;m;m/=10)
        num[++len]=m%10;
    return dfs(len,1,0,1);
}
int main()
{
    memset(dp,-1,sizeof(dp));
    for(int i=1,j=0;i<=2520;i++)
        a[i]=2520%i?0:++j;  //对最小公倍数的离散
    for(int j=0;j<10;j++)
        for(int i=0;i<252;i++)
            b[i][j]=(i*10+j)%252;  //这里是处理余数
    int t;
    LL m,n;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%I64d%I64d",&m,&n);
        printf("%I64d\n",getans(n)-getans(m-1));
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值